org.bdgenomics.adam.rdd.contig

# NucleotideContigFragmentRDD

###
Related Docs: object NucleotideContigFragmentRDD | package contig

#### sealed abstract class NucleotideContigFragmentRDD extends AvroGenomicRDD[NucleotideContigFragment, NucleotideContigFragment, NucleotideContigFragmentRDD]

Linear Supertypes
AvroGenomicRDD[NucleotideContigFragment, NucleotideContigFragment, NucleotideContigFragmentRDD], GenomicDataset[NucleotideContigFragment, NucleotideContigFragment, NucleotideContigFragmentRDD], GenomicRDD[NucleotideContigFragment, NucleotideContigFragmentRDD], ADAMRDDFunctions[NucleotideContigFragment], Logging, Serializable, Serializable, AnyRef, Any
Known Subclasses
DatasetBoundNucleotideContigFragmentRDD, ParquetUnboundNucleotideContigFragmentRDD, RDDBoundNucleotideContigFragmentRDD
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. NucleotideContigFragmentRDD
2. AvroGenomicRDD
3. GenomicDataset
4. GenomicRDD
5. ADAMRDDFunctions
6. Logging
7. Serializable
8. Serializable
9. AnyRef
10. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract val dataset: Dataset[NucleotideContigFragment]

   This data as a Spark SQL Dataset.

   This data as a Spark SQL Dataset.

   Definition Classes
     GenomicDataset

2. #### abstract val optPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]]

   Attributes
     protected
   Definition Classes
     GenomicRDD

3. #### abstract val rdd: RDD[NucleotideContigFragment]

   The RDD of genomic data that we are wrapping.

   The RDD of genomic data that we are wrapping.

   Definition Classes
     GenomicRDD

4. #### abstract def replaceSequences(newSequences: SequenceDictionary): NucleotideContigFragmentRDD

   Replaces the sequence dictionary attached to a GenomicRDD.

   Replaces the sequence dictionary attached to a GenomicRDD.

   newSequences

     The new sequence dictionary to attach.

   returns

     Returns a new GenomicRDD with the sequences replaced.

   Definition Classes
     GenomicRDD

5. #### abstract val sequences: SequenceDictionary

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   The sequence dictionary describing the reference assembly this dataset is aligned to.

   Definition Classes
     GenomicRDD

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### def addSequence(sequenceToAdd: SequenceRecord): NucleotideContigFragmentRDD

   Appends metadata for a single sequence to the current RDD.

   Appends metadata for a single sequence to the current RDD.

   sequenceToAdd

     The sequence to add.

   returns

     Returns a new GenomicRDD with this sequence appended.

   Definition Classes
     GenomicRDD

5. #### def addSequences(sequencesToAdd: SequenceDictionary): NucleotideContigFragmentRDD

   Appends sequence metadata to the current RDD.

   Appends sequence metadata to the current RDD.

   sequencesToAdd

     The new sequences to append.

   returns

     Returns a new GenomicRDD with the sequences appended.

   Definition Classes
     GenomicRDD

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### def broadcast()(implicit tTag: ClassTag[NucleotideContigFragment]): Broadcast[IntervalArray[ReferenceRegion, NucleotideContigFragment]]

   Definition Classes
     GenomicRDD

8. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], txTag: ClassTag[(NucleotideContigFragment, X)]): GenericGenomicRDD[(NucleotideContigFragment, X)]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD
   See also

     broadcastRegionJoinAgainst

9. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], txTag: ClassTag[(NucleotideContigFragment, X)]): GenericGenomicRDD[(NucleotideContigFragment, X)]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   flankSize

     Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD
   See also

     broadcastRegionJoinAgainst

10. #### def broadcastRegionJoinAgainst[X](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X]): GenericGenomicRDD[(X, NucleotideContigFragment)]

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    Performs a broadcast inner join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoin

11. #### def broadcastRegionJoinAgainstAndGroupByRight[X, Y <: GenomicRDD[X, Y]](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X]): GenericGenomicRDD[(Iterable[X], NucleotideContigFragment)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      broadcastRegionJoinAndGroupByRight

12. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[NucleotideContigFragment], X)]): GenericGenomicRDD[(Iterable[NucleotideContigFragment], X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainstAndGroupByRight

13. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[NucleotideContigFragment], X)]): GenericGenomicRDD[(Iterable[NucleotideContigFragment], X)]

    Performs a broadcast inner join between this RDD and another RDD.

    Performs a broadcast inner join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    See also

      broadcastRegionJoinAgainstAndGroupByRight

14. #### def buildTree(rdd: RDD[(ReferenceRegion, NucleotideContigFragment)])(implicit tTag: ClassTag[NucleotideContigFragment]): IntervalArray[ReferenceRegion, NucleotideContigFragment]

    Attributes
      protected
    Definition Classes
      NucleotideContigFragmentRDD → GenomicRDD

15. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

16. #### def countKmers(kmerLength: Integer): JavaRDD[(String, Long)]

    Counts the k-mers contained in a FASTA contig.

    Counts the k-mers contained in a FASTA contig.

    Java friendly variant.

    kmerLength

      The length of k-mers to count.

    returns

      Returns an RDD containing k-mer/count pairs.

17. #### def countKmers(kmerLength: Int): RDD[(String, Long)]

    Counts the k-mers contained in a FASTA contig.

    Counts the k-mers contained in a FASTA contig.

    kmerLength

      The length of k-mers to count.

    returns

      Returns an RDD containing k-mer/count pairs.

18. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

20. #### def extract(region: ReferenceRegion): String

    From a set of contigs, returns the base sequence that corresponds to a region of the reference.

    From a set of contigs, returns the base sequence that corresponds to a region of the reference.

    region

      Reference region over which to get sequence.

    returns

      String of bases corresponding to reference sequence.

    Exceptions thrown

      `UnsupportedOperationException` Throws exception if query region is not found.

21. #### def extractRegions(regions: Iterable[ReferenceRegion]): RDD[(ReferenceRegion, String)]

    From a set of contigs, returns a list of sequences based on reference regions provided

    From a set of contigs, returns a list of sequences based on reference regions provided

    regions

      List of Reference regions over which to get sequences

    returns

      RDD[(ReferenceRegion, String)] of region -> sequence pairs.

22. #### def filterByOverlappingRegion(query: ReferenceRegion): NucleotideContigFragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the query region.

    Definition Classes
      GenomicRDD

23. #### def filterByOverlappingRegions(querys: Iterable[ReferenceRegion]): NucleotideContigFragmentRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicRDD

24. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

25. #### def flankAdjacentFragments(flankLength: Int): NucleotideContigFragmentRDD

    For all adjacent records in the RDD, we extend the records so that the adjacent records now overlap by _n_ bases, where _n_ is the flank length.

    For all adjacent records in the RDD, we extend the records so that the adjacent records now overlap by _n_ bases, where _n_ is the flank length.

    flankLength

      The length to extend adjacent records by.

    returns

      Returns the RDD, with all adjacent fragments extended with flanking sequence.

26. #### def flankAdjacentFragments(flankLength: Integer): NucleotideContigFragmentRDD

    For all adjacent records in the RDD, we extend the records so that the adjacent records now overlap by _n_ bases, where _n_ is the flank length.

    For all adjacent records in the RDD, we extend the records so that the adjacent records now overlap by _n_ bases, where _n_ is the flank length.

    Java friendly variant.

    flankLength

      The length to extend adjacent records by.

    returns

      Returns the RDD, with all adjacent fragments extended with flanking sequence.

27. #### def flattenRddByRegions(): RDD[(ReferenceRegion, NucleotideContigFragment)]

    Attributes
      protected
    Definition Classes
      GenomicRDD

28. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[NucleotideContigFragment], Option[X])]): GenericGenomicRDD[(Option[NucleotideContigFragment], Option[X])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

29. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otoxTag: ClassTag[(Option[NucleotideContigFragment], Option[X])]): GenericGenomicRDD[(Option[NucleotideContigFragment], Option[X])]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

30. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

31. #### def getReferenceRegions(elem: NucleotideContigFragment): Seq[ReferenceRegion]

    elem

      Fragment to extract a region from.

    returns

      If a fragment is aligned to a reference location, returns a single reference region. If the fragment start position and name is not defined, returns no regions.

    Attributes
      protected
    Definition Classes
      NucleotideContigFragmentRDD → GenomicRDD

32. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

33. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

34. #### def isSorted: Boolean

    Definition Classes
      GenomicRDD

35. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

36. #### lazy val jrdd: JavaRDD[NucleotideContigFragment]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicRDD

37. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], toxTag: ClassTag[(NucleotideContigFragment, Option[X])]): GenericGenomicRDD[(NucleotideContigFragment, Option[X])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

38. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], toxTag: ClassTag[(NucleotideContigFragment, Option[X])]): GenericGenomicRDD[(NucleotideContigFragment, Option[X])]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

39. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], toxTag: ClassTag[(NucleotideContigFragment, Iterable[X])]): GenericGenomicRDD[(NucleotideContigFragment, Iterable[X])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

40. #### def leftOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], toxTag: ClassTag[(NucleotideContigFragment, Iterable[X])]): GenericGenomicRDD[(NucleotideContigFragment, Iterable[X])]

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge left outer join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with an empty Iterable in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

41. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

42. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

43. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

44. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

45. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

46. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

47. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

48. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

49. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

50. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

51. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

52. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

53. #### def mergeFragments(): NucleotideContigFragmentRDD

    Merge fragments by contig name.

    Merge fragments by contig name.

    returns

      Returns a NucleotideContigFragmentRDD containing a single fragment per contig.

54. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

55. #### final def notify(): Unit

    Definition Classes
      AnyRef

56. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

57. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[NucleotideContigFragment, NucleotideContigFragmentRDD, V]](cmd: String, files: List[String], environment: Map[String, String], flankSize: Integer, tFormatter: Class[V], xFormatter: OutFormatter[X], convFn: Function2[NucleotideContigFragmentRDD, RDD[X], Y]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Java/PySpark friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

58. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[NucleotideContigFragment, NucleotideContigFragmentRDD, V]](cmd: String, files: Seq[Any], environment: Map[Any, Any], flankSize: Double, tFormatter: Class[V], xFormatter: OutFormatter[X], convFn: Function2[NucleotideContigFragmentRDD, RDD[X], Y]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    SparkR friendly variant.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    tFormatter

      Class of formatter for data going into pipe command.

    xFormatter

      Formatter for data coming out of the pipe command.

    convFn

      The conversion function used to build the final RDD.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

59. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[NucleotideContigFragment, NucleotideContigFragmentRDD, V]](cmd: String, files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0)(implicit tFormatterCompanion: InFormatterCompanion[NucleotideContigFragment, NucleotideContigFragmentRDD, V], xFormatter: OutFormatter[X], convFn: (NucleotideContigFragmentRDD, RDD[X]) ⇒ Y, tManifest: ClassTag[NucleotideContigFragment], xManifest: ClassTag[X]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0. To access the path to the directory where the files are copied, use $root.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicRDD. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

60. #### def replaceRdd(newRdd: RDD[NucleotideContigFragment], newPartitionMap: Option[Array[Option[(ReferenceRegion, ReferenceRegion)]]] = None): NucleotideContigFragmentRDD

    Replaces the underlying RDD with a new RDD.

    Replaces the underlying RDD with a new RDD.

    newRdd

      The RDD to use for the new NucleotideContigFragmentRDD.

    returns

      Returns a new NucleotideContigFragmentRDD where the underlying RDD has been replaced.

    Attributes
      protected
    Definition Classes
      NucleotideContigFragmentRDD → GenomicRDD

61. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[NucleotideContigFragment], X)]): GenericGenomicRDD[(Option[NucleotideContigFragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoin

62. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[NucleotideContigFragment], X)]): GenericGenomicRDD[(Option[NucleotideContigFragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoin

63. #### def rightOuterBroadcastRegionJoinAgainst[X](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X]): GenericGenomicRDD[(Option[X], NucleotideContigFragment)]

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    Performs a broadcast right outer join between this RDD and data that has been broadcast.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoin

64. #### def rightOuterBroadcastRegionJoinAgainstAndGroupByRight[X, Y <: GenomicRDD[X, Y]](broadcastTree: Broadcast[IntervalArray[ReferenceRegion, X]])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X]): GenericGenomicRDD[(Iterable[X], NucleotideContigFragment)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left table that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left table, it will be paired with a `None` in the product of the join. As compared to broadcastRegionJoin, this function allows the broadcast object to be reused across multiple joins.

    broadcastTree

      The data on the left side of the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD
    Note

      This function differs from other region joins as it treats the calling RDD as the right side of the join, and not the left.

    See also

      rightOuterBroadcastRegionJoinAndGroupByRight

65. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[NucleotideContigFragment], X)]): GenericGenomicRDD[(Iterable[NucleotideContigFragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

66. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], itxTag: ClassTag[(Iterable[NucleotideContigFragment], X)]): GenericGenomicRDD[(Iterable[NucleotideContigFragment], X)]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left side of the join (broadcastTree) is broadcast to to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD
    See also

      rightOuterBroadcastRegionJoinAgainstAndGroupByRight

67. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[NucleotideContigFragment], X)]): GenericGenomicRDD[(Option[NucleotideContigFragment], X)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

68. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otxTag: ClassTag[(Option[NucleotideContigFragment], X)]): GenericGenomicRDD[(Option[NucleotideContigFragment], X)]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

69. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[NucleotideContigFragment], Iterable[X])]): GenericGenomicRDD[(Option[NucleotideContigFragment], Iterable[X])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

70. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], otixTag: ClassTag[(Option[NucleotideContigFragment], Iterable[X])]): GenericGenomicRDD[(Option[NucleotideContigFragment], Iterable[X])]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

71. #### def save(fileName: String, asSingleFile: Boolean): Unit

    Save nucleotide contig fragments as Parquet or FASTA.

    Save nucleotide contig fragments as Parquet or FASTA.

    If filename ends in .fa or .fasta, saves as Fasta. If not, saves fragments to Parquet. Defaults to 60 character line length, if saving to FASTA.

    fileName

      file name

    asSingleFile

      If false, writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

72. #### def saveAsFasta(fileName: String, lineWidth: Int = 60, asSingleFile: Boolean = false, disableFastConcat: Boolean = false): Unit

    Save nucleotide contig fragments in FASTA format.

    Save nucleotide contig fragments in FASTA format.

    fileName

      file name

    lineWidth

      hard wrap FASTA formatted sequence at line width, default 60

    asSingleFile

      By default (false), writes file to disk as shards with one shard per partition. If true, we save the file to disk as a single file by merging the shards.

    disableFastConcat

      If asSingleFile is true, disables the use of the parallel file merging engine.

73. #### def saveAsParquet(filePath: String): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    Definition Classes
      AvroGenomicRDD

74. #### def saveAsParquet(filePath: String, blockSize: Integer, pageSize: Integer, compressCodec: CompressionCodecName, disableDictionaryEncoding: Boolean): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing.

    Definition Classes
      AvroGenomicRDD

75. #### def saveAsParquet(filePath: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false): Unit

    Saves this RDD to disk as a Parquet file.

    Saves this RDD to disk as a Parquet file.

    filePath

      Path to save the file at.

    blockSize

      Size per block.

    pageSize

      Size per page.

    compressCodec

      Name of the compression codec to use.

    disableDictionaryEncoding

      Whether or not to disable bit-packing. Default is false.

    Definition Classes
      AvroGenomicRDD

76. #### def saveAsParquet(args: SaveArgs): Unit

    Saves RDD as a directory of Parquet files.

    Saves RDD as a directory of Parquet files.

    The RDD is written as a directory of Parquet files, with Parquet configuration described by the input param args. The provided sequence dictionary is written at args.outputPath/_seqdict.avro as Avro binary.

    args

      Save configuration arguments.

    Definition Classes
      AvroGenomicRDD

77. #### def saveAvro[U <: SpecificRecordBase](pathName: String, sc: SparkContext, schema: Schema, avro: Seq[U])(implicit tUag: ClassTag[U]): Unit

    Saves Avro data to a Hadoop file system.

    Saves Avro data to a Hadoop file system.

    This method uses a SparkContext to identify our underlying file system, which we then save to.

    Frustratingly enough, although all records generated by the Avro IDL compiler have a static SCHEMA$ field, this field does not belong to the SpecificRecordBase abstract class, or the SpecificRecord interface. As such, we must force the user to pass in the schema.

    U

      The type of the specific record we are saving.

    pathName

      Path to save records to.

    sc

      SparkContext used for identifying underlying file system.

    schema

      Schema of records we are saving.

    avro

      Seq of records we are saving.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

78. #### def saveMetadata(filePath: String): Unit

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Called in saveAsParquet after saving RDD to Parquet to save metadata.

    Writes any necessary metadata to disk. If not overridden, writes the sequence dictionary to disk as Avro.

    filePath

      The filepath to the file where we will save the Metadata.

    Attributes
      protected
    Definition Classes
      AvroGenomicRDD

79. #### def savePartitionMap(filePath: String): Unit

    Save the partition map to disk.

    Save the partition map to disk. This is done by adding the partition map to the schema.

    filePath

      The filepath where we will save the partition map.

    Attributes
      protected
    Definition Classes
      AvroGenomicRDD

80. #### def saveRddAsParquet(pathName: String, blockSize: Int = 128 * 1024 * 1024, pageSize: Int = 1 * 1024 * 1024, compressCodec: CompressionCodecName = CompressionCodecName.GZIP, disableDictionaryEncoding: Boolean = false, optSchema: Option[Schema] = None): Unit

    Saves an RDD of Avro data to Parquet.

    Saves an RDD of Avro data to Parquet.

    pathName

      The path to save the file to.

    blockSize

      The size in bytes of blocks to write. Defaults to 128 * 1024 * 1024.

    pageSize

      The size in bytes of pages to write. Defaults to 1 * 1024 * 1024.

    compressCodec

      The compression codec to apply to pages. Defaults to CompressionCodecName.GZIP.

    disableDictionaryEncoding

      If false, dictionary encoding is used. If true, delta encoding is used. Defaults to false.

    optSchema

      The optional schema to set. Defaults to None.

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

81. #### def saveRddAsParquet(args: SaveArgs): Unit

    Attributes
      protected
    Definition Classes
      ADAMRDDFunctions

82. #### def saveSequences(filePath: String): Unit

    Save the sequence dictionary to disk.

    Save the sequence dictionary to disk.

    filePath

      The filepath where we will save the sequence dictionary.

    Attributes
      protected
    Definition Classes
      AvroGenomicRDD

83. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], txTag: ClassTag[(NucleotideContigFragment, X)]): GenericGenomicRDD[(NucleotideContigFragment, X)]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

84. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], txTag: ClassTag[(NucleotideContigFragment, X)]): GenericGenomicRDD[(NucleotideContigFragment, X)]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

85. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], tixTag: ClassTag[(NucleotideContigFragment, Iterable[X])]): GenericGenomicRDD[(NucleotideContigFragment, Iterable[X])]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

86. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y]](genomicRdd: GenomicRDD[X, Y], flankSize: Long)(implicit tTag: ClassTag[NucleotideContigFragment], xTag: ClassTag[X], tixTag: ClassTag[(NucleotideContigFragment, Iterable[X])]): GenericGenomicRDD[(NucleotideContigFragment, Iterable[X])]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    flankSize

      Sets a flankSize for the distance between elements to be joined. If set to 0, an overlap is required to join two elements.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

87. #### def sort(partitions: Int = rdd.partitions.length, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[NucleotideContigFragment]): NucleotideContigFragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    partitions

      The number of partitions for the new RDD.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Uses ValidationStringency to handle unaligned or where objects align to multiple positions.

    See also

      sortLexicographically

88. #### def sort(): NucleotideContigFragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    See also

      sortLexicographically

89. #### def sortLexicographically(partitions: Int = rdd.partitions.length, storePartitionMap: Boolean = false, storageLevel: StorageLevel = StorageLevel.MEMORY_ONLY, stringency: ValidationStringency = ValidationStringency.STRICT)(implicit tTag: ClassTag[NucleotideContigFragment]): NucleotideContigFragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    partitions

      The number of partitions for the new RDD.

    storePartitionMap

      A Boolean flag to determine whether to store the partition bounds from the resulting RDD.

    storageLevel

      The level at which to persist the resulting RDD.

    stringency

      The level of ValidationStringency to enforce.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Uses ValidationStringency to handle data that is unaligned or where objects align to multiple positions.

    See also

      sort

90. #### def sortLexicographically(): NucleotideContigFragmentRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    See also

      sort

91. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

92. #### def toDF(): DataFrame

    returns

      This data as a Spark SQL DataFrame.

    Definition Classes
      GenomicDataset

93. #### def toReads: RDD[AlignmentRecord]

    Converts an RDD of nucleotide contig fragments into reads.

    Converts an RDD of nucleotide contig fragments into reads. Adjacent contig fragments are combined.

    returns

      Returns an RDD of reads.

94. #### def toString(): String

    Definition Classes
      GenomicRDD → AnyRef → Any

95. #### def transform(tFn: Function[JavaRDD[NucleotideContigFragment], JavaRDD[NucleotideContigFragment]]): NucleotideContigFragmentRDD

    Applies a function that transforms the underlying RDD into a new RDD.

    Applies a function that transforms the underlying RDD into a new RDD.

    tFn

      A function that transforms the underlying RDD.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicRDD

96. #### def transform(tFn: (RDD[NucleotideContigFragment]) ⇒ RDD[NucleotideContigFragment]): NucleotideContigFragmentRDD

    Applies a function that transforms the underlying RDD into a new RDD.

    Applies a function that transforms the underlying RDD into a new RDD.

    tFn

      A function that transforms the underlying RDD.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicRDD

97. #### def transformDataFrame(tFn: Function[DataFrame, DataFrame]): NucleotideContigFragmentRDD

    Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

    Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API. Java-friendly variant.

    tFn

      A function that transforms the underlying RDD as a DataFrame.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicDataset

98. #### def transformDataFrame(tFn: (DataFrame) ⇒ DataFrame)(implicit uTag: scala.reflect.api.JavaUniverse.TypeTag[NucleotideContigFragment]): NucleotideContigFragmentRDD

    Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

    Applies a function that transforms the underlying DataFrame into a new DataFrame using the Spark SQL API.

    tFn

      A function that transforms the underlying RDD as a DataFrame.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicDataset

99. #### def transformDataset(tFn: (Dataset[NucleotideContigFragment]) ⇒ Dataset[NucleotideContigFragment]): NucleotideContigFragmentRDD

    Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

    Applies a function that transforms the underlying RDD into a new RDD using the Spark SQL API.

    tFn

      A function that transforms the underlying RDD as a Dataset.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      NucleotideContigFragmentRDD → GenomicDataset

100. #### def transmute[X, Y <: GenomicRDD[X, Y]](tFn: Function[JavaRDD[NucleotideContigFragment], JavaRDD[X]], convFn: Function2[NucleotideContigFragmentRDD, RDD[X], Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly version.

     tFn

       A function that transforms the underlying RDD.

     convFn

       The conversion function used to build the final RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

101. #### def transmute[X, Y <: GenomicRDD[X, Y]](tFn: (RDD[NucleotideContigFragment]) ⇒ RDD[X])(implicit convFn: (NucleotideContigFragmentRDD, RDD[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicRDD

102. #### def transmuteDataFrame[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: Function[DataFrame, DataFrame], convFn: GenomicDatasetConversion[NucleotideContigFragment, NucleotideContigFragmentRDD, X, Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

103. #### def transmuteDataFrame[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: (DataFrame) ⇒ DataFrame)(implicit xTag: scala.reflect.api.JavaUniverse.TypeTag[X], convFn: (NucleotideContigFragmentRDD, Dataset[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

104. #### def transmuteDataset[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: Function[Dataset[NucleotideContigFragment], Dataset[X]], convFn: GenomicDatasetConversion[NucleotideContigFragment, NucleotideContigFragmentRDD, X, Y]): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type. Java friendly variant.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

105. #### def transmuteDataset[X <: Product, Y <: GenomicDataset[_, X, Y]](tFn: (Dataset[NucleotideContigFragment]) ⇒ Dataset[X])(implicit xTag: scala.reflect.api.JavaUniverse.TypeTag[X], convFn: (NucleotideContigFragmentRDD, Dataset[X]) ⇒ Y): Y

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     Applies a function that transmutes the underlying RDD into a new RDD of a different type.

     tFn

       A function that transforms the underlying RDD.

     returns

       A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

     Definition Classes
       GenomicDataset

106. #### val uTag: scala.reflect.api.JavaUniverse.TypeTag[NucleotideContigFragment]

     Definition Classes
       NucleotideContigFragmentRDD → GenomicDataset

107. #### def union(rdds: NucleotideContigFragmentRDD*): NucleotideContigFragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       NucleotideContigFragmentRDD → GenomicRDD

108. #### def union(rdds: List[NucleotideContigFragmentRDD]): NucleotideContigFragmentRDD

     Unions together multiple genomic RDDs.

     Unions together multiple genomic RDDs.

     rdds

       RDDs to union with this RDD.

     Definition Classes
       GenomicRDD

109. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

110. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

111. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

112. #### def writeTextRdd[T](rdd: RDD[T], outputPath: String, asSingleFile: Boolean, disableFastConcat: Boolean, optHeaderPath: Option[String] = None): Unit

     Writes an RDD to disk as text and optionally merges.

     Writes an RDD to disk as text and optionally merges.

     rdd

       RDD to save.

     outputPath

       Output path to save text files to.

     asSingleFile

       If true, combines all partition shards.

     disableFastConcat

       If asSingleFile is true, disables the use of the parallel file merging engine.

     optHeaderPath

       If provided, the header file to include.

     Attributes
       protected
     Definition Classes
       GenomicRDD

### Inherited from AvroGenomicRDD[NucleotideContigFragment, NucleotideContigFragment, NucleotideContigFragmentRDD]

### Inherited from GenomicDataset[NucleotideContigFragment, NucleotideContigFragment, NucleotideContigFragmentRDD]

### Inherited from GenomicRDD[NucleotideContigFragment, NucleotideContigFragmentRDD]

### Inherited from ADAMRDDFunctions[NucleotideContigFragment]

### Inherited from Logging

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any

### Ungrouped